# -*- coding: utf-8 -*-
from setuphelpers import *
from setupdevhelpers import *
import re


def update_package():
    # Déclaration des variables locales
    result = False
    proxies = get_proxies()  # Supposons que cette fonction récupère une liste de proxies
    if not proxies:
        proxies = get_proxies_from_wapt_console()  # Fonction pour récupérer des proxies depuis WAPT

    
    url = "https://eid.belgium.be/en"

    response = requests.get(url)
    # Recherche des balises <div> contenant les liens de téléchargement
    download_section = bs_find_all(url, 'div','class','field field--name-field-link field--type-link field--label-hidden field__item')
    
    if not download_section:
        print("Section de téléchargement non trouvée.")
        return False

    # Expression régulière pour trouver les liens correspondants à /download/{number}/license
    regex = re.compile(r'/download/\d+/license')

    # Recherche du lien de téléchargement spécifique
    download_links = []
    for section in download_section:
        for link in section.find_all('a', href=True):
            href = link['href']
            print(f"Lien extrait: {href}")  # Afficher chaque lien extrait pour le débogage
            if regex.search(href):
                download_link = f"https://eid.belgium.be{href}"
                break
        if download_link:
            break
    # Accéder à la page de téléchargement et extraire le lien vers le fichier .exe
    exe_link = None
    try:
        dl_response = requests.get(download_link, proxies=proxies, timeout=10)
        dl_response.raise_for_status()
        exe_tag = bs_find_all(download_link,"span","class","file file--mime-application-x-msdos-program file--general")
        if exe_tag:
            # Chercher la balise <a> à l'intérieur de la balise <span>
            a_tag = exe_tag[0].find('a', href=True)
            if a_tag and 'href' in a_tag.attrs:
                exe_link = a_tag['href']
                if not exe_link.startswith('http'):
                    exe_link = f"https://eid.belgium.be{exe_link}"
                    download_url  = exe_link
                    latest_bin = download_url.split("/")[-1]
    except requests.exceptions.RequestException as e:
        print(f"Erreur lors de l'accès au lien de téléchargement {download_link} : {e}")  
    # Affiner l'expression régulière pour correspondre exactement à la version après "QuickInstaller%20"
    match = re.search(r'QuickInstaller%20(\d+\.\d+\.\d+\.\d+)', latest_bin)

    if match:
        version = match.group(1)
        print(f"La version extraite est : {version}")
    else:
        print("Aucune version trouvée dans le nom de fichier.")

    #nettoyer les fichiers temporaires
    for f in glob.glob('*.exe'):
        if f != latest_bin:
            remove_file(f)

    # Downloading latest binaries
    if not isfile(latest_bin):
        package_updated = True
        print("Downloading: %s" % latest_bin)
        wget(download_url, latest_bin, proxies=proxies)

    
    
    control.set_software_version(version)
    control.save_control_to_wapt()    